#version 450
 
struct PerFrameUniforms
{
    mat4 gViewMat4;
    mat4 gViewProjectionMat4;
    mat4 gCameraMat4;
    vec3 gViewPositionVec3;
    float gfTime;
    vec4 gFrameBufferSizeVec4;
};

struct CommonPerMeshUniforms
{
    vec4 gPlanetPositionVec4;
    mat4 gWorldMat4;
    float gfFadeValue;
    vec4 gaSkinMatrixRowsVec4[225];
    vec4 gaPrevSkinMatrixRowsVec4[225];
};

struct CustomPerMaterialUniforms
{
    vec4 gImposterDataVec4;
    vec4 gTileBlendScalesVec4;
    vec4 gHueOverlayParamsVec4;
    vec4 gSaturationOverlayParamsVec4;
    vec4 gValueOverlayParamsVec4;
    vec4 gTerrainColour1Vec4;
    vec4 gTerrainColour2Vec4;
};

struct CustomPerMeshUniforms
{
    vec4 gUVScrollStepVec4;
    vec4 gCustomParams01Vec4;
    vec4 gBboxDepthAndClips;
};

struct UniformBuffer
{
    PerFrameUniforms mpPerFrame;
    CommonPerMeshUniforms mpCommonPerMesh;
    CustomPerMaterialUniforms mpCustomPerMaterial;
    CustomPerMeshUniforms mpCustomPerMesh;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
layout(set = 0, binding = 45, std140) uniform Vk3DParams
{
    vec4 stereo;
    vec4 custom_params;
} vk3d_params;

layout(set = 0, binding = 0, std140) uniform lUniforms_BLK
{
    UniformBuffer lUniforms;
} _62;

layout(location = 0) in vec4 mkLocalPositionVec4;
layout(location = 1) in vec4 mkTexCoordsVec4;
layout(location = 6) in vec4 mkWeightsVec4;
layout(location = 5) in vec4 mkJointsVec4;
layout(location = 0) out VertexBlock
{
    vec4 mScreenSpacePositionVec4;
    vec4 mTexCoordsVec4;
} Out;

layout(location = 7) in vec4 mkLocalNormalVec4;
layout(location = 3) in vec4 mkTangentVec4;
layout(location = 8) in vec4 mkColourVec4;

mat4 _1659;

void main()
{
    vec4 _1608 = mkLocalPositionVec4;
    _1608.w = 1.0;
    int _1522 = int(mkJointsVec4.x) * 3;
    mat4 _1611 = _1659;
    _1611[0] = _62.lUniforms.mpCommonPerMesh.gaSkinMatrixRowsVec4[_1522];
    mat4 _1613 = _1611;
    _1613[1] = _62.lUniforms.mpCommonPerMesh.gaSkinMatrixRowsVec4[_1522 + 1];
    mat4 _1615 = _1613;
    _1615[2] = _62.lUniforms.mpCommonPerMesh.gaSkinMatrixRowsVec4[_1522 + 2];
    mat4 _1617 = _1615;
    _1617[3] = vec4(0.0, 0.0, 0.0, 1.0);
    vec4 _1460 = (_1608 * _1617) * mkWeightsVec4.x;
    vec4 _1661;
    if (mkWeightsVec4.y > 0.001000000047497451305389404296875)
    {
        int _1543 = int(mkJointsVec4.y) * 3;
        mat4 _1622 = _1659;
        _1622[0] = _62.lUniforms.mpCommonPerMesh.gaSkinMatrixRowsVec4[_1543];
        mat4 _1624 = _1622;
        _1624[1] = _62.lUniforms.mpCommonPerMesh.gaSkinMatrixRowsVec4[_1543 + 1];
        mat4 _1626 = _1624;
        _1626[2] = _62.lUniforms.mpCommonPerMesh.gaSkinMatrixRowsVec4[_1543 + 2];
        mat4 _1628 = _1626;
        _1628[3] = vec4(0.0, 0.0, 0.0, 1.0);
        _1661 = _1460 + ((_1608 * _1628) * mkWeightsVec4.y);
    }
    else
    {
        _1661 = _1460;
    }
    vec4 _1664;
    if (mkWeightsVec4.z > 0.001000000047497451305389404296875)
    {
        int _1564 = int(mkJointsVec4.z) * 3;
        mat4 _1633 = _1659;
        _1633[0] = _62.lUniforms.mpCommonPerMesh.gaSkinMatrixRowsVec4[_1564];
        mat4 _1635 = _1633;
        _1635[1] = _62.lUniforms.mpCommonPerMesh.gaSkinMatrixRowsVec4[_1564 + 1];
        mat4 _1637 = _1635;
        _1637[2] = _62.lUniforms.mpCommonPerMesh.gaSkinMatrixRowsVec4[_1564 + 2];
        mat4 _1639 = _1637;
        _1639[3] = vec4(0.0, 0.0, 0.0, 1.0);
        _1664 = _1661 + ((_1608 * _1639) * mkWeightsVec4.z);
    }
    else
    {
        _1664 = _1661;
    }
    vec4 _1665;
    if (mkWeightsVec4.w > 0.001000000047497451305389404296875)
    {
        int _1585 = int(mkJointsVec4.w) * 3;
        mat4 _1644 = _1659;
        _1644[0] = _62.lUniforms.mpCommonPerMesh.gaSkinMatrixRowsVec4[_1585];
        mat4 _1646 = _1644;
        _1646[1] = _62.lUniforms.mpCommonPerMesh.gaSkinMatrixRowsVec4[_1585 + 1];
        mat4 _1648 = _1646;
        _1648[2] = _62.lUniforms.mpCommonPerMesh.gaSkinMatrixRowsVec4[_1585 + 2];
        mat4 _1650 = _1648;
        _1650[3] = vec4(0.0, 0.0, 0.0, 1.0);
        _1665 = _1664 + ((_1608 * _1650) * mkWeightsVec4.w);
    }
    else
    {
        _1665 = _1664;
    }
    Out.mTexCoordsVec4 = vec4(mkTexCoordsVec4.x, mkTexCoordsVec4.y, mkTexCoordsVec4.z, mkTexCoordsVec4.w);
    vec4 _1606 = _62.lUniforms.mpPerFrame.gViewProjectionMat4 * (_62.lUniforms.mpCommonPerMesh.gWorldMat4 * (_1665 / vec4(max(_1665.w, 9.9999999747524270787835121154785e-07))));
    vec4 _1658 = _1606;
    _1658.z = 0.5 - (max(_1606.z, -1.0) * 0.5);
    Out.mScreenSpacePositionVec4 = _1658;
    gl_Position = _1658;

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
//gl_Position.x -= vk3d_params.stereo.x * (gl_Position.w - vk3d_params.stereo.y); 

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
//gl_Position.x += vk3d_params.stereo.x * (gl_Position.w - vk3d_params.stereo.y); 
}


